structure SetTag : TAG = 
  struct
    type tag = Var.Set.set
    fun fresh_anonymous_tag() = Var.Set.singleton(Var.fresh_anonymous_var())
    val empty = Var.Set.empty
    val union = Var.Set.union
    val difference = Var.Set.difference
    fun toString(vs) =  
      String.concatWith "," (List.map Var.toString (Var.Set.listItems vs))
    fun listItems t = List.map (Var.toString) (Var.Set.listItems t)
    val equal = Var.Set.equal
  end
